diff --git a/src/backend/commands/explain.c b/src/backend/commands/explain.c
index c0d614866a..a1395edc8c 100644
--- a/src/backend/commands/explain.c
+++ b/src/backend/commands/explain.c
@@ -2075,7 +2075,7 @@ ExplainNode(PlanState *planstate, List *ancestors,
 				ExplainIndentText(es);
 				appendStringInfo(es->str, "actual ");
 				if (es->timing)
-					appendStringInfo(es->str, "time=%.3f..%.3f", startup_ms, total_ms);
+					appendStringInfo(es->str, "time=%.3f..%.3f ", startup_ms, total_ms);
 
 				if (nloops > 1)
 					appendStringInfo(es->str, "rows=%.2f loops=%.0f\n", rows, nloops);